move pidl build into the compiler loop
[build-farm.git] / build_test.fns
1 #!/bin/sh -*- mode: shell-script; -*-
2
3 # build_farm -- distributed build/test architecture for samba, rsync, etc
4
5 # Copyright (C) 2001 by Andrew Tridgell <tridge@samba.org>
6 # Copyright (C) 2001 by Andrew Bartlett <abartlet@samba.org>
7 # Copyright (C) 2001, 2003 by Martin Pool <mbp@samba.org>
8
9 # default maximum runtime for any command
10 MAXTIME=25200 # 7 hours
11 SMBD_MAXTIME=18000 # 5 hours for a samba process ..
12 # default maximum memory size (100M) for any command
13 MAXMEM=100000
14 RUN_FROM_BUILD_FARM=yes
15 export RUN_FROM_BUILD_FARM
16 export MAXTIME SMBD_MAXTIME
17
18 deptrees="";
19
20 build_test_fns_id='$Id$'
21
22 copy_dir() {
23         Tsrc=$1
24         Tdst=$2
25         pwd
26         echo rsync -a --delete $Tsrc/ $Tdst
27         rsync -a --delete $Tsrc/ $Tdst || return 1
28         return 0
29 }
30
31 #############################
32 # build a signature of a tree, used to see if we
33 # need to rebuild 
34 #############################
35
36 sum_tree() {
37         sum_tree_test_root=$1
38         sum_tree_tree=$2
39         sum_tree_sum=$3
40         sum_tree_scm=$4
41         find $sum_tree_test_root/$sum_tree_tree -type f -print | grep -v version.h | sort | xargs sum > $sum_tree_sum
42         sum build_test build_test.fns >> $sum_tree_sum
43
44         if [ -f "$host.fns" ]; then
45                 sum $host.fns >> $sum_tree_sum
46         else
47                 sum generic.fns >> $sum_tree_sum
48         fi
49
50         if [ -f "$test_root/$tree.$scm" ]; then
51                 sum "$test_root/$tree.$scm" >> $sum_tree_sum
52         fi
53
54         for d in $deptrees; do
55                 dscm=`choose_scm "$d"`
56                 if [ -f "$test_root/$d.$dscm" ]; then
57                 sum "$test_root/$d.$dscm" >> $sum_tree_sum
58                 fi
59         done
60 }
61
62 #############################
63 # send the logs to the master site
64 #############################
65
66 send_logs() {
67         if [ "$nologreturn" = "yes" ]; then
68                 echo "skipping log transfer"
69         else
70                 log="$1"
71                 err="$2"
72                 shift
73                 shift
74                 chmod 0644 "$log" "$err"
75
76                 # xargs -i is implemented differently or not at all.
77                 # GNU xargs did not implement "-I" until 4.2.9:
78                 xargs --version 2>&1 | grep "^GNU xargs" > /dev/null
79                 status=$?
80                 if [ x"$status" = x"0" ]; then
81                         XARGS_IS_GNU=yes
82                 fi
83
84                 if [ x"$XARGS_IS_GNU" = x"yes" ]; then
85                         XARGS_I="xargs -i"
86                 else
87                         XARGS_I="xargs -I '{}'"
88                 fi
89
90                 find $log -size +40000 | $XARGS_I sh -c 'dd if={} bs=1024 count=20000 of={}.tmp && mv {}.tmp {} &&  echo "\n***LOG TRUNCATED***" >> {}'
91                 find $err -size +40000 | $XARGS_I sh -c 'dd if={} bs=1024 count=20000 of={}.tmp && mv {}.tmp {} &&  echo "\n***LOG TRUNCATED***" >> {}'
92
93                 rsync $* -c -q --password-file=.password -z --timeout=200 \
94                         "$log" "$err" $host@build.samba.org::build_farm_data/
95         fi
96 }
97
98 #############################
99 # send the logs when they haven't changed
100 # the aim is to just update the servers timestamp.
101 # sending with a very large rsync block size does this
102 # with minimal network traffic
103 #############################
104
105 send_logs_skip() {
106         touch "$1" "$2"
107         send_logs "$1" "$2" -B 10000000
108 }
109
110 ############################
111 # fetch the latest copy of the tree
112 ############################
113
114 fetch_tree() {
115         if [ "$norsync" = "yes" ]; then
116                 echo "skipping tree transfer"
117         else
118                 fetchtree=$1
119                 if rsync --exclude=autom4te.cache/ --exclude=.svn/ --exclude=.git/ \
120                         --delete-excluded -q --partial --timeout=200 -ctrlpz --delete --ignore-errors \
121                         samba.org::ftp/unpacked/$fetchtree/ $test_root/$fetchtree; then
122                         echo "transferred $fetchtree OK"
123                 else
124                         echo "transfer of $fetchtree failed code $?"
125                         return 1
126                 fi
127         fi
128         return 0
129 }
130
131 ############################
132 # fetch the latest copy of the rev meta info
133 ############################
134
135 fetch_revinfo() {
136         tree=$1
137         scm=$2
138
139         test -z "$scm" && return 1
140         test x"$scm" = x"unknown" && return 1
141         test x"$scm" = x"cvs" && return 1
142
143         if [ "$norsync" = "yes" ]; then
144                 echo "skipping .revinfo.$scm transfer"
145         else
146                 if [ -r $test_root/$tree.$scm ]; then
147                         [ -f $test_root/$tree.$scm.old ] && rm -f $test_root/$tree.$scm.old
148                         [ -f $test_root/$tree.$scm ] && mv $test_root/$tree.$scm $test_root/$tree.$scm.old
149                 fi
150                 rsync -q --timeout=200 -clz --ignore-errors \
151                         samba.org::ftp/unpacked/$tree/.revinfo.$scm $test_root/$tree.$scm
152         fi
153         if [ -r $test_root/$tree.$scm ]; then
154                 return 0;
155         fi
156         return 1
157 }
158
159 ############################
160 # choose the scm that is used for the given project
161 ############################
162
163 choose_scm() {
164         tree=$1
165
166         case "$tree" in
167                         samba* | rsync | libreplace | talloc | tdb* | ldb | pidl | ccache* | waf*)
168                         echo "git"
169                                 return 0
170                         ;;
171         esac
172
173         echo "svn"
174         return 0
175 }
176
177 locknesting=0
178
179 ############################
180 # grab a lock file. Not atomic, but close :)
181 # tries to cope with NFS
182 ############################
183
184 lock_file() {
185                 if [ -z "$lock_root" ]; then
186                         lock_root=`pwd`;
187                 fi
188
189                 lckf="$lock_root/$1"
190                 machine=`cat "$lckf" 2> /dev/null | cut -d: -f1`
191                 pid=`cat "$lckf" 2> /dev/null | cut -d: -f2`
192
193                 if [ "$pid" = "$$" ]; then
194                         locknesting=`expr $locknesting + 1`
195                         echo "lock nesting now $locknesting"
196                         return 0
197                 fi
198
199                 # We need to assert that the file is > 0 size, as otherwise we never
200                 # recover from disk full situations
201                 if test -f "$lckf" && test -s "$lckf"; then
202                         test x$machine = x$host || {
203                                 echo "lock file $lckf is valid for other machine $machine"
204                                 return 1
205                         }
206
207                         kill -0 $pid && {
208                                 echo "lock file $lckf is valid for process $pid"
209                                 return 1
210                         }
211
212                         echo "stale lock file $lckf for $machine:$pid"
213                         cat "$lckf"
214                         /bin/rm -f "$lckf"
215                 fi
216                 echo "$host:$$" > "$lckf"
217                 return 0
218 }
219
220 ############################
221 # unlock a lock file
222 ############################
223
224 unlock_file() {
225         if [ -z "$lock_root" ]; then
226                 lock_root=`pwd`;
227         fi
228         if [ "$locknesting" != "0" ]; then
229                 locknesting=`expr $locknesting - 1`
230                 echo "lock nesting now $locknesting"
231         else 
232                 lckf="$lock_root/$1"
233                 /bin/rm -f "$lckf"
234         fi
235 }
236
237 ############################
238 # run make, and print trace
239 ############################
240
241 do_make() {
242         # work out correct make command
243         case "$tree" in
244             waf*)
245                 MAKECOMMAND="./waf"
246                 ;;
247             *)
248                 MAKECOMMAND="$MAKE"
249                 if [ x"$MAKECOMMAND" = x ]; then
250                     MAKECOMMAND=make
251                 fi
252                 ;;
253         esac
254
255         MMTIME=$MAXTIME
256         # some trees don't need as much time
257         case "$tree" in
258                 rsync | tdb* | talloc | libreplace | ccache* | waf*)
259                         if [ "$compiler" != "checker" ]; then
260                                 MMTIME=`expr $MMTIME / 5`
261                         fi
262                 ;;
263         esac
264
265         # special build for some trees
266         case "$tree" in
267             waf*)
268                 ./waf distclean && ./waf configure build
269                 ;;
270         esac
271
272
273         for t in $*; do
274                 if [ x"$BUILD_FARM_NUM_JOBS" = x ]; then
275                         echo "$MAKECOMMAND $t"
276                         $builddir/timelimit $MMTIME "$MAKECOMMAND" "$t"
277                         status=$?
278                 else
279                         # we can parallelize everything and all targets
280                         if [ x"$t" = xeverything ] || [ x"$t" = xall]; then
281                                 echo "$MAKECOMMAND" "-j$BUILD_FARM_NUM_JOBS"  "$t"
282                                 $builddir/timelimit $MMTIME "$MAKECOMMAND" "-j$BUILD_FARM_NUM_JOBS"  "$t"
283                                 status=$?
284                         else
285                                 echo "$MAKECOMMAND $t"
286                                 $builddir/timelimit $MMTIME "$MAKECOMMAND" "$t"
287                                 status=$?
288                         fi
289                 fi
290
291                 if [ $status != 0 ]; then
292                         case "$t" in
293                                 test|check|installcheck)
294                                         ;;
295                                 *)
296                                         #run again with V=1, so we see failed commands
297                                         $builddir/timelimit $MMTIME "$MAKECOMMAND" "$t" V=1
298                                         status=$?
299                                         ;;
300                         esac
301                 fi
302
303                 if [ $status != 0 ]; then
304                         return $status;
305                 fi
306
307         done
308
309         return 0
310 }
311
312
313 ############################
314 # do the coverage report
315 ############################
316
317 action_lcovreport() {
318         if [ "$LCOV_REPORT" = "yes" ]; then
319                 case "$tree" in
320                 lorikeet-heimdal*)
321                         lcov --directory $builddir --capture --output-file $builddir/$tree.lcov.info
322                         ;;
323                 samba_3_master*)
324                         lcov --base-directory $builddir --directory $builddir/.. --capture --output-file $builddir/$tree.lcov.info
325                         ;;
326                 samba_4*|tdb*|talloc|ldb|libreplace)
327                         lcov --base-directory $builddir/bin --directory $builddir/bin --capture --output-file $builddir/$tree.lcov.info
328                         ;;
329                 waf)
330                         lcov --base-directory $builddir/demos --directory $builddir/demos --capture --output-file $builddir/$tree.lcov.info
331                         ;;
332                 *)
333                         lcov --base-directory $builddir --directory $builddir --capture --output-file $builddir/$tree.lcov.info
334                         ;;
335                 esac
336                 genhtml -o $builddir/coverage $builddir/$tree.lcov.info
337                 rc=$?
338                 echo "return code: $rc"
339         else
340                 echo "LCOV_REPORT not set and lcovreport asked"
341                 echo "Most probably an error please fix !"
342                 return 1
343         fi
344 }
345
346 action_callcatcherreport() {
347         if [ "$CALLCATCHER_REPORT" = "yes" ]; then
348                 case "$tree" in
349                 tdb*|talloc|ldb)
350                         callanalyse `find $builddir/bin -name \*.so*` $builddir/bin/* > $builddir/coverage/unused-fns.txt
351                         ;;
352                 samba_3_master|samba_4*)
353                         callanalyse `find $builddir/bin -name \*.so*` $builddir/bin/* > $builddir/coverage/all-unused-fns.txt 
354                         grep -v -f $srcdir/callcatcher-exceptions.grep $builddir/coverage/all-unused-fns.txt > $builddir/coverage/unused-fns.txt
355                         ;;
356                 esac
357                 rc=$?
358                 echo "return code: $rc"
359         else
360                 echo "CALLCATCHER_REPORT not set and callcatcher asked"
361                 echo "Most probably an error please fix !"
362                 return 1
363         fi
364 }
365
366
367 ############################
368 # configure the tree
369 ############################
370
371 action_configure() {
372         # special handling for some trees
373         case "$tree" in
374             waf*)
375                 $builddir/timelimit $MAXTIME ./waf configure
376                 cstatus=$?
377                 echo "CONFIGURE STATUS: $cstatus"
378                 return $cstatus
379                 ;;
380         esac
381
382         if [ ! -x $srcdir/configure -a -r $srcdir/Makefile.PL ]; then
383                 perl $srcdir/Makefile.PL PREFIX="$prefix"
384                 cstatus=$?
385                 echo "CONFIGURE STATUS: $cstatus"
386                 return $cstatus;
387         fi
388
389         if [ ! -x $srcdir/configure ]; then
390                 ls -l $srcdir/configure
391                 echo "$srcdir/configure is missing"
392                 cstatus=255
393                 echo "CONFIGURE STATUS: $cstatus"
394                 return $cstatus;
395         fi
396
397         echo "CFLAGS=$CFLAGS"
398         echo configure options: $config_and_prefix
399         echo CC="$CCACHE $compiler" $srcdir/configure $config_and_prefix
400
401         CC="$CCACHE $compiler"
402         export CC
403         $builddir/timelimit $MAXTIME $srcdir/configure $config_and_prefix
404         cstatus=$?
405
406         if [ x"$cstatus" != x"0" ]; then
407                 if [ -f config.log ]; then
408                         echo "contents of config.log:"
409                         cat config.log
410                 fi
411
412                 # Waf style
413                 if [ -f bin/config.log ]; then
414                         echo "contents of config.log:"
415                         cat bin/config.log
416                 fi
417         fi
418         echo "CONFIGURE STATUS: $cstatus"
419         return $cstatus
420 }
421
422 ############################
423 # show the configure log
424 ############################
425
426 action_config_log() {
427
428         log_files="config.log bin/config.log"
429         for f in $log_files; do
430                 if [ -f $f ]; then
431                         echo "contents of config.log:"
432                         cat $f
433                         return 0
434                 fi
435         done
436         return 0
437 }
438
439 ############################
440 # show the config.h
441 ############################
442
443 action_config_header() {
444         hdr_files="config.h include/config.h include/autoconf/config.h bin/default/config.h bin/default/include/config.h bin/default/source3/include/config.h"
445         for h in $hdr_files; do
446                 if [ -f $h ]; then
447                         echo "contents of $h:"
448                         cat $h
449                         return 0
450                 fi
451         done
452
453         return 0
454 }
455
456
457
458 ############################
459 # build the tree
460 ############################
461 action_build() {
462         case "$tree" in
463         samba_4*)
464                 do_make everything
465                 bstatus=$?
466                 ;;
467         samba_3*)
468                 do_make everything torture
469                 bstatus=$?
470                 ;;
471         waf*)
472                 do_make build
473                 bstatus=$?
474                 ;;
475         *)
476                 do_make all
477                 bstatus=$?
478                 ;;
479         esac
480
481         echo "BUILD STATUS: $bstatus"
482
483         return $bstatus
484 }
485
486 ############################
487 # show static analysis results
488 ############################
489
490 action_cc_checker() {
491
492         # default to passing the cc_checker
493         cccstatus=0
494
495         if [ -f ibm_checker.out ]; then
496                 cat ibm_checker.out
497                 cccstatus=`cat ibm_checker.out | grep '^\-\- ' | wc -l`
498         fi
499
500         echo "CC_CHECKER STATUS: $cccstatus"
501         return $cccstatus;      
502 }
503
504 ############################
505 # install the tree
506 ############################
507
508 action_install() {
509         if [ -d $prefix ]; then
510                 if [ "$noclean" != "yes" ]; then
511                         rm -rf $prefix
512                 fi
513         fi
514
515         do_make install
516         istatus=$?
517         echo "INSTALL STATUS: $istatus"
518         return $istatus;
519 }
520
521 ############################
522 # test the tree
523 action_test_samba() {
524         do_make test
525         totalstatus=$?
526
527         # if we produced a test summary then show it
528         [ -f st/summary ] && {
529                 echo "TEST SUMMARY"
530                 cat st/summary
531         }
532
533         return "$totalstatus"
534 }
535
536 action_test_generic() {
537         CC="$compiler"
538         export CC
539         do_make installcheck
540         totalstatus=$?
541         echo "TEST STATUS: $totalstatus"
542         return "$totalstatus"
543 }
544
545 action_test_lorikeet_heimdal() {
546         CC="$compiler"
547         export CC
548         SOCKET_WRAPPER_DIR=`pwd`/sw
549         mkdir $SOCKET_WRAPPER_DIR
550         export SOCKET_WRAPPER_DIR
551         do_make check
552         totalstatus=$?
553         SOCKET_WRAPPER_DIR=
554         export SOCKET_WRAPPER_DIR
555         echo "TEST STATUS: $totalstatus"
556         return "$totalstatus"
557 }
558
559
560 #############################
561 # attempt some basic tests of functionaility
562 # starting as basic as possible, and getting incresingly complex
563 #############################
564
565 action_test() {
566         # Samba needs crufty code of its own for backward
567         # compatiblity.  I think a better way to do this in the future
568         # is to just call 'make installcheck'.
569         case "$tree" in
570         samba*|smb-build|pidl)
571                 action_test_samba
572                 ;;
573         lorikeet-heimdal*)
574                 action_test_lorikeet_heimdal
575                 ;;
576         *)
577                 action_test_generic
578                 ;;
579         esac
580 }
581
582 ###########################
583 # do a test build of a particular tree
584 # This is the master function called by generic.fns or
585 # host.fns
586 ###########################
587
588 test_tree() {
589         tree=$1
590         source=$2
591         compiler="$3"
592         shift
593         shift
594         shift
595         echo "Starting to deal with tree $tree with compiler $compiler"
596         if [ "$compiler" = "gcc" ] && [ "$tree" != "ccache" ] && [ "$tree" != "ccache-maint" ] && ccache -V > /dev/null 2>/dev/null; then
597                 CCACHE="ccache"
598                 export CCACHE
599         else
600                 CCACHE=""
601         fi
602
603         # limit our resource usage
604         ulimit -t $MAXTIME 2> /dev/null
605
606         # max mem size 100M
607         ulimit -m $MAXMEM 2> /dev/null
608
609         # max file size 100M
610         # darn, this affects sparse files too! disable it
611         # ulimit -f 100000 2> /dev/null
612
613         # try and limit the number of open files to 250. That means we'll discover
614         # fd leaks faster
615         ulimit -n 250 2> /dev/null
616
617         # Keep stuff private
618         umask 077
619
620         if [ -z "$test_root" ]; then
621                 test_root=`pwd`
622         fi
623
624         log="build.$tree.$host.$compiler.log"
625         err="build.$tree.$host.$compiler.err"
626         sum="build.$tree.$host.$compiler.sum"
627         lck="build.$tree.lck"
628                 srcdir="$test_root/$tree/$source"
629
630         lock_file "$lck" || {
631                 return
632         }
633
634         # work out what other trees this package depends on
635         deptrees=""
636         case "$tree" in
637                 samba-gtk)
638                 deptrees="samba_4_0_test"
639                 ;;
640         esac
641
642         scm=`choose_scm "$tree"`
643
644         # pull the entries, if any
645         # Remove old .svn or .git files
646         # Move the current .svn org .git to .svn.old or
647         # .git.old then fetch the new from rsync
648         if fetch_revinfo "$tree" "$scm"; then
649                 for d in $deptrees; do
650                         # If there is dependency substree(s) we add info
651                         # from the dependency tree so that we
652                         # can rebuild in case one of them has changed
653                         dscm=`choose_scm "$d"`
654                         if [ -f "$test_root/$d.$dscm" ]; then
655                                 if [ "$d" != "$tree" ]; then
656                                         cat "$test_root/$d.$dscm" >> $test_root/$tree.$scm
657                                 fi
658                         fi
659                 done
660                 [ -f $test_root/$tree.$compiler.$scm.old ] && rm -f $test_root/$tree.$compiler.$scm.old
661                 [ -f $test_root/$tree.$compiler.$scm ] && mv $test_root/$tree.$compiler.$scm $test_root/$tree.$compiler.$scm.old
662                 [ -f $test_root/$tree.$scm ] && cp $test_root/$tree.$scm $test_root/$tree.$compiler.$scm
663
664                 if [ -f $test_root/$tree.$compiler.$scm.old ] && \
665                                 cmp $test_root/$tree.$compiler.$scm $test_root/$tree.$compiler.$scm.old > /dev/null; then
666
667                         echo "skip: $tree.$compiler nothing changed in $scm"
668                         cd $test_root
669                         send_logs_skip "$log" "$err"
670                         unlock_file "$lck"
671                         return
672                 fi
673         fi
674
675         # pull the tree
676         fetch_tree "$tree" || {
677                 cd $test_root
678                 unlock_file "$lck"
679                 return
680         }
681
682         # check for essential files
683         case "$tree" in
684             pidl)
685                 # no generated files
686                 ;;
687             waf*)
688                 if [ ! -x $srcdir/waf ]; then
689                     echo "skip: $tree.$compiler waf not present, try again next time!"
690                     cd $test_root
691                     unlock_file "$lck"
692                     return
693                 fi
694                 ;;
695             *)
696                 if [ ! -x $srcdir/configure ]; then
697                     echo "skip: $tree.$compiler configure not present, try again next time!"
698                     cd $test_root
699                     unlock_file "$lck"
700                     return
701                 fi
702                 ;;
703         esac
704
705         echo "Starting build of $tree.$compiler in process $$ at `date`"
706
707
708         # Parameters for the build depending on the tree
709         case "$tree" in
710                 *)
711                         builddir=$srcdir
712                         export builddir
713                         ;;
714         esac
715
716         #Fix the user
717         if [ ! x$USER = x"" ]; then
718                 whoami=$USER
719         else 
720                 if [ ! x$LOGNAME = x"" ]; then
721                         whoami=$LOGNAME
722                 else
723                         whoami=build
724                 fi
725         fi
726
727         # build the timelimit utility
728         echo "Building timelimit"
729         mkdir -p $builddir
730         echo $compiler $TIMELIMIT_FLAGS -o $builddir/timelimit $test_root/timelimit.c
731         $compiler $TIMELIMIT_FLAGS -o $builddir/timelimit $test_root/timelimit.c || exit 1
732
733         # build the killbysubdir utility
734         echo "Building killbysubdir"
735         echo $compiler -o $builddir/killbysubdir $test_root/killbysubdir.c
736         $compiler -o $builddir/killbysubdir $test_root/killbysubdir.c
737
738         prefix="$test_root/prefix/$tree.$compiler"
739         mkdir -p "$prefix"
740
741         # This can be defined in <host>.fns files
742         sw_config=$config
743
744         case "$tree" in
745         lorikeet-heimdal)
746                 sw_config="$config --enable-socket-wrapper"
747                 ;;
748         samba_4*)
749                 sw_config="$config --enable-selftest"
750                 ;;
751         samba_3_master)
752                 sw_config="$config --enable-selftest"
753                 ;;
754         samba_3*)
755                 sw_config="$config --enable-socket-wrapper"
756                 sw_config="$sw_config --enable-nss-wrapper"
757                 ;;
758         samba-gtk)
759                 PKG_CONFIG_PATH="$test_root/prefix/samba_4_0_test.$compiler/lib/pkgconfig"
760                 export PKG_CONFIG_PATH
761                 ;;
762         *)
763                 testsuite=testsuite
764                 ;;
765         esac
766
767         if [ "$LCOV_REPORT" = "yes" ]; then
768                 PRE_GCOV_CFLAGS=$CFLAGS
769                 PRE_GCOV_LDFLAGS=$LDFLAGS
770                 GCOV_FLAGS="--coverage"
771                 CFLAGS="$CFLAGS $GCOV_FLAGS" 
772                 LDFLAGS="$LDFLAGS $GCOV_FLAGS" 
773                 export CFLAGS LDFLAGS
774         fi
775
776         config_and_prefix="$sw_config --prefix=$prefix"
777
778         # see if we need to rebuild
779         sum_tree $test_root $tree $sum $scm
780         echo "CFLAGS=$CFLAGS $config_and_prefix" >> $sum
781
782         if [ -f "$sum.old" ] && cmp "$sum" "$sum.old" > /dev/null; then
783                 echo "skip: $tree.$compiler nothing changed"
784                 cd $test_root
785                 send_logs_skip "$log" "$err"
786                 unlock_file "$lck"
787                 echo "Ending build of $tree.$compiler in process $$ at `date`"
788                 if [ "$LCOV_REPORT" = "yes" ]; then
789                     CFLAGS=$PRE_GCOV_CFLAGS
790                     LDFLAGS=$PRE_GCOV_LDFLAGS
791                     export CFLAGS LDFLAGS
792                 fi
793                 return
794         fi
795
796         # we do need to rebuild - save the old sum
797         [ -f $sum.old ] && /bin/rm -f $sum.old
798         mv $sum $sum.old
799
800         #Action == what to do ie. configure config_log ...
801         actions="$*"
802
803         if [ "$actions" = "" ]; then
804                 actions="configure config_log config_header build install test $EXTRA_ACTIONS"
805         fi
806
807         # start the build
808         (
809         {
810                 # we all want to be able to read the output...
811                 LANG=C
812                 export LANG
813
814                 uname -a
815
816                 echo ""
817                 echo "build_test                  : $build_test_id"
818                 echo "build_test.fns      : $build_test_fns_id"
819                 echo "local settings file : $build_test_settings_local_file"
820                 echo "local functions file: $build_test_fns_local_file"
821                 echo "used .fns file      : $build_test_used_fns_file"
822                 echo ""
823
824                 # we need to be able to see if a build farm machine is accumulating
825                 # stuck processes. We do this in two ways, as we don't know what style
826                 # of ps it will have
827                 ps xfuw 2> /dev/null
828                 ps -fu $USER 2> /dev/null
829
830                 echo "building $tree with CC=$compiler on $host at "`date`
831                 echo "builddir=$builddir"
832                 echo "prefix=$prefix"
833
834                 echo "Showing limits"
835                 ulimit -a 2> /dev/null
836
837                 # the following is for non-samba builds only
838                 if [ "$scm" = "svn" -a -r $test_root/$tree.svn ]; then
839                         h_rev=`grep 'Revision: ' $test_root/$tree.svn | cut -d ':' -f2 | cut -d ' ' -f2 | sed 1q`
840                         if [ -n "$h_rev" ]; then
841                                 echo "HIGHEST SVN REVISION: $h_rev"
842                         fi
843                         rev=`grep 'Last Changed Rev: ' $test_root/$tree.svn | cut -d ':' -f2 | cut -d ' ' -f2 | sed 1q`
844                         if [ -n "$rev" ]; then
845                         echo "BUILD REVISION: $rev"
846                         fi
847                 elif [ "$scm" = "git" -a -r $test_root/$tree.git ]; then
848                         csha1=`cat $test_root/$tree.git |head -3 | tail -1`
849                         if [ -n "$csha1" ]; then
850                                 echo "BUILD COMMIT REVISION: $csha1"
851                         fi
852                         cdate=`cat $test_root/$tree.git |head -4 | tail -1`
853                         if [ -n "$cdate" ]; then
854                                 echo "BUILD COMMIT DATE: $cdate"
855                         fi
856                         ctime=`cat $test_root/$tree.git |head -2 | tail -1`
857                         if [ -n "$ctime" ]; then
858                                 echo "BUILD COMMIT TIME: $ctime"
859                   fi
860                 fi
861
862                 if [ -x $builddir/killbysubdir ]; then
863                         echo "$builddir/killbysubdir $builddir in `pwd`"
864                         $builddir/killbysubdir $builddir
865                 fi
866
867                 for action in $actions; do
868
869                         echo Running action $action
870
871                         date
872
873                         cd $builddir || exit 1
874                         export srcdir
875                         df .
876                         mount
877                         vmstat
878
879                         if [ "x$PREHOOKS" != "x" ]; then
880                                 for hooks in $PREHOOKS; do
881                                         if [ "x$hooks" = "x$action" ]; then
882                                                 ( prehook_$action )
883                                         fi
884                                 done
885                         fi
886
887                         ( action_$action )
888                         action_status=$?
889
890                         if [ "x$POSTHOOKS" != "x" ]; then
891                                 for hooks in $POSTHOOKS; do
892                                         if [ "x$hooks" = "x$action" ]; then
893                                                 ( posthook_$action )
894                                         fi
895                                 done
896                         fi
897
898                         df .
899
900                         if [ $action_status != 0 ]; then
901                                 echo "ACTION FAILED: $action";
902                                 echo " return code $action_status $action";
903                         else
904                                 echo "ACTION PASSED: $action";
905                         fi
906
907                         if [ $action_status != 0 ]; then 
908                                 break;
909                         fi
910                 done
911
912
913                 if [ "$noclean" = "yes" ]; then
914                         echo cleanup skipped!
915                 else
916                         echo cleaning up
917                         do_make clean
918                 fi
919                 date
920         } 3>&2 2>&1 1>&3 | tee "$err"
921         ) > "$log" 2>&1
922         # be aware the above channel swap may sometimes result in unordered
923         # stdout/stderr merge
924
925         if [ "$LCOV_REPORT" = "yes" ]; then
926                 chmod u=rwX,g=rX,o=rX -R $builddir/coverage
927                 rsync -rct -q --password-file=.password -z --timeout=200 \
928                         $builddir/coverage/ $host@build.samba.org::lcov_data/$host/$tree/
929                 CFLAGS=$PRE_GCOV_CFLAGS
930                 LDFLAGS=$PRE_GCOV_LDFLAGS
931                 export CFLAGS LDFLAGS
932         fi
933
934         cd $test_root
935
936         /bin/rm -rf $prefix
937         # send the logs to the master site
938         send_logs "$log" "$err"
939
940         # cleanup
941         echo "Ending build of $tree.$compiler in process $$ at `date`"
942         unlock_file "$lck"
943 }
944
945 #########################################################
946 # if you want to build only one project at a time
947 # add 'global_lock' after 'per_run_hook' and
948 # 'global_unlock' to the end of the file
949 #########################################################
950
951 global_lock() {
952         lock_file "global.lck" || {
953                 exit 0
954         }
955 }
956
957 global_unlock() {
958         unlock_file "global.lck"
959 }
960
961 delete_old_tree() {
962         otree=$1
963         test -z "$otree" && return 0;
964
965         rm -rf $otree
966         rm -rf $otree.svn
967         rm -rf $otree.*.svn
968         rm -rf $otree.git
969         rm -rf $otree.*.git
970         rm -rf build.$otree.*
971 }
972
973 # this is a special fn that allows us to add a "special" hook to the build
974 # farm that we want to do to the build farm. never leave it empty. instead,
975 # use ":" as the fn body.
976 per_run_hook() {
977         # kill old processes on systems with a known problem
978         case $host in
979         nohost)
980                 echo "just a placeholder";
981                 ;;
982         deckchair)
983                 rm -f deckchair.fns
984                 ;;
985         esac
986
987         # trim the log if too large
988         if [ "`wc -c < build.log`" -gt 2000000 ]; then
989         rm -f build.log
990         fi
991
992         old_trees="web popt distcc samba-gtk smb-build lorikeet-heimdal samba_3_2"
993         old_trees="$old_tree samba_3_2_test samba4 samba_4_0_waf samba_4_0_waf.metze"
994         old_trees="$old_tree samba_3_X_test samba_3_X_devel samba_3_X_devel samba_3_waf"
995         for d in $old_trees; do
996                 delete_old_tree $d
997         done
998 }
999
1000
1001 ######################################################
1002 # main code that is run on each call to the build code
1003 ######################################################
1004 rsync --timeout=200 -q -az build.samba.org::build_farm/*.c .
1005
1006
1007 # build.log can grow to an excessive size, trim it beyond 50M
1008 if [ -f build.log ]; then
1009         find build.log -size +100000 -exec /bin/rm '{}' \;
1010 fi